﻿Imports System.Data
Imports System.Data.OleDb

Public Class DABase
    Implements IDisposable

    Public SQL As String
    Public Connection As OleDbConnection
    Public Command As OleDbCommand
    Public DataAdapter As OleDbDataAdapter
    Public DataReader As OleDbDataReader

   
    Public Sub New(ByVal uid As String, ByVal pwd As String, ByVal PortNO As String, ByVal DataBase As String, ByVal HostName As String)
        Connection = New OleDbConnection("Provider=IBMDADB2;Mode=Read;PROTOCOL=TCPIP;" & "PORT=" & PortNO & ";" & "UID=" & uid & ";" &
                                         "pwd=" & pwd & ";" & "Database=" &
                                         DataBase & ";" & "Persist Security Info=False;" & "HOSTNAME=" & HostName)
    End Sub
  
#Region "IDisposable Support"
    Private disposedValue As Boolean ' 检测冗余的调用

    ' IDisposable
    Protected Overridable Sub Dispose(ByVal disposing As Boolean)
        If Not Me.disposedValue Then
            If disposing Then
                ' TODO: 释放托管状态(托管对象)。
                If Not DataReader Is Nothing Then
                    DataReader.Close()
                    DataReader = Nothing
                End If
                If Not DataAdapter Is Nothing Then
                    DataAdapter.Dispose()
                    DataAdapter = Nothing
                End If
                If Not Command Is Nothing Then
                    Command.Dispose()
                    Command = Nothing
                End If
                If Not Connection Is Nothing Then
                    Connection.Close()
                    Connection.Dispose()
                    Connection = Nothing
                End If
            End If

            ' TODO: 释放非托管资源(非托管对象)并重写下面的 Finalize()。
            ' TODO: 将大型字段设置为 null。
        End If
        Me.disposedValue = True
    End Sub

    ' TODO: 仅当上面的 Dispose(ByVal disposing As Boolean)具有释放非托管资源的代码时重写 Finalize()。
    'Protected Overrides Sub Finalize()
    '    ' 不要更改此代码。请将清理代码放入上面的 Dispose(ByVal disposing As Boolean)中。
    '    Dispose(False)
    '    MyBase.Finalize()
    'End Sub

    ' Visual Basic 添加此代码是为了正确实现可处置模式。
    Public Sub Dispose() Implements IDisposable.Dispose
        ' 不要更改此代码。请将清理代码放入上面的 Dispose(ByVal disposing As Boolean)中。
        Dispose(True)
        GC.SuppressFinalize(Me)
    End Sub
#End Region
    Public Sub OpenConnection()
        Try
            Connection.Open()

        Catch oledbExceptionErr As OleDbException
            Throw New System.Exception(oledbExceptionErr.Message, oledbExceptionErr.InnerException)
        Catch InvalidOperationExceptionErr As InvalidOperationException
            Throw New System.Exception(InvalidOperationExceptionErr.Message, InvalidOperationExceptionErr.InnerException)
        End Try
    End Sub
    Public Sub CloseConnection()
        Connection.Close()
    End Sub
    Public Sub InitializeCommand()
        If Command Is Nothing Then
            Try
                Command = New OleDbCommand(SQL, Connection)
                If Not SQL.Trim.ToUpper.StartsWith("SELECT ") AndAlso Not SQL.Trim.ToUpper.StartsWith("DELETE ") _
 AndAlso Not SQL.Trim.ToUpper.StartsWith("INSERT ") AndAlso Not SQL.Trim.ToUpper.StartsWith("UPDATE ") Then
                    Command.CommandType = CommandType.StoredProcedure
                End If
            Catch ex As OleDbException
                Throw New Exception(ex.Message, ex.InnerException)
            End Try
        End If

    End Sub
    Public Sub AddParameter(ByVal Name As String, ByVal Type As OleDbType, ByVal Size As Integer, ByVal Value As Object)
        Try
            Command.Parameters.Add(Name, Type, Size).Value = Value

        Catch ex As OleDbException
            Throw New Exception(ex.Message, ex.InnerException)

        End Try
    End Sub
    Public Sub AddParameter(ByVal Name As String, ByVal Value As Object)
        Try
            Command.Parameters.AddWithValue(Name, Value)
        Catch ex As OleDbException
            Throw New Exception(ex.Message, ex.InnerException)
        End Try
    End Sub
    Public Sub InitializeDataAdapter()
        Try
            DataAdapter = New OleDbDataAdapter
            DataAdapter.SelectCommand = Command
        Catch ex As OleDbException
            Throw New Exception(ex.Message, ex.InnerException)
        End Try
    End Sub
    Public Sub FillDataSet(ByVal oDataSet As DataSet, ByVal tableName As String)
        Try
            InitializeCommand()
            InitializeDataAdapter()
            DataAdapter.Fill(oDataSet, tableName)
        Catch ex As OleDbException
            Throw New Exception(ex.Message, ex.InnerException)
        Finally
            Command.Dispose()
            Command = Nothing
            DataAdapter.Dispose()
            DataAdapter = Nothing
        End Try
    End Sub
    Public Sub FillDataTable(ByRef odataTable As DataTable)
        Try
            InitializeCommand()
            InitializeDataAdapter()
            DataAdapter.Fill(odataTable)
        Catch ex As OleDbException
            Throw New Exception(ex.Message, ex.InnerException)
        Finally
            Command.Dispose()
            Command = Nothing
            DataAdapter.Dispose()
            DataAdapter = Nothing
        End Try
    End Sub
    Public Function ExecuteStoredProcedure() As Integer
        Try
            OpenConnection()
            ExecuteStoredProcedure = Command.ExecuteNonQuery
        Catch ex As OleDbException
            Throw New Exception(ex.Message, ex.InnerException)
        Finally
            CloseConnection()
        End Try
    End Function

    Public Function Status() As Boolean
        Try

            Return Connection.State
        Catch ex As OleDbException
            Throw New Exception(ex.Message, ex.InnerException)
        End Try
      
    End Function
    'Public Function QueryDBreader() As OleDbDataReader
    '    ' Try
    '    OpenConnection()
    '    InitializeCommand()
    '    QueryDBreader = Command.ExecuteReader
    '    ' Catch ex As OleDbException
    '    'Throw New Exception(ex.Message)
    '    ' Finally
    '    CloseConnection()
    '    '  End Try
    'End Function
End Class
